/**
 * Created by mx on 2017/3/16.
 */
var IO = require('socket.io-client'),
    EVENT_NAME = {
        CONNECT: "connect",
        CONNECT_ERROR: "connect_error",
        CONNECT_TIMEOUT: "connect_timeout"
    };

module.exports = function(module){
    module.provider("socketIOService" , function(){
        var _this = this;
        _this.$get = ["$q" , function($q){
            return {
                /**
                 * 连接socket
                 * @param url
                 * @param options
                 * @returns {*}
                 */
                connect: function(url , options){
                    var defer = $q.defer(),
                        socket = new IO(url , options);

                    this.socket = socket;
                    socket.on(EVENT_NAME.CONNECT , function(){
                        defer.resolve();
                    });
                    socket.on(EVENT_NAME.CONNECT_ERROR , function(err){
                        defer.reject(err);
                    });
                    socket.on(EVENT_NAME.CONNECT_TIMEOUT , function(err){
                        defer.reject(err);
                    });
                    return defer.promise;
                },
                /**
                 * 添加监听事件
                 * @param eventName
                 * @returns {*}
                 */
                addEvent: function(eventName){
                    var defer = $q.defer();
                    this.socket.on(eventName , function(data , fn){
                        defer.notify({data: data, fn: fn});
                    });
                    return defer.promise;
                },
                /**
                 * 发送消息
                 * @param eventName
                 * @param data
                 * @returns {*}
                 */
                emit: function(eventName , data){
                    var defer = $q.defer();
                    this.socket.emit(eventName, data , function (data) {
                        defer.resolve(data);
                    });
                    return defer.promise;
                }
            };
        }];
    });
};